#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "SDL.h"

#define WIW 480
#define WIH 320
#define REC 4
#define PAI 3.1415926f

SDL_Surface *screen;
Uint32 now,fps,cnt,clr;//flame late

struct bullet_Val//自弾の構造体
{
Sint16	flg,
				cnt;//画面更新までのカウント
double	poX,poY,//現在地
				moX,moY,//移動量
				spd,rot;//スピードと角度
};struct bullet_Val blt;

//------------------------------------------------------------------------------準備
void inits()
{
//初期化
if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_JOYSTICK|SDL_INIT_AUDIO)<0)
	{
	fprintf(stderr, "SDL が初期化できませんでした: %s\n", SDL_GetError());
	SDL_Quit();return;
	}
screen=SDL_SetVideoMode(WIW,WIH,32,SDL_SWSURFACE);
SDL_WM_SetCaption("Bullet", NULL);
srand((unsigned)time(NULL));
}
//------------------------------------------------------------------------------画面更新
void upDate()
{
if(SDL_GetTicks()-now<16)SDL_Delay(16-(SDL_GetTicks()-now));
now=SDL_GetTicks();
SDL_UpdateRect(screen,0,0,0,0);//画面更新
if(SDL_GetTicks()-fps>=5000)
	{
	printf("%d\n",(Uint32)(cnt/5+0.5));cnt=1;fps=now;
	}
else cnt++;
}
//------------------------------------------------------------------------------終了へ
int quitLoop()
{
SDL_Event endSDL;
if(SDL_PollEvent(&endSDL))
switch(endSDL.type)
	{
	case SDL_KEYDOWN:
		if(endSDL.key.keysym.sym==SDLK_ESCAPE)return 0;
		break;
	case SDL_QUIT:		return 0;
	default:					break;
	}
return 1;
}
//------------------------------------------------------------------------------自分
void me()
{
SDL_Rect pos;
pos.x=WIW*0.5-REC*0.5;  pos.y=WIH*0.5-REC*0.5;	pos.w=REC;  pos.h=REC;
SDL_FillRect(screen,&pos,SDL_MapRGB(screen->format,0,255,255));
}
//------------------------------------------------------------------------------弾
void bullet_src(double poX,double poY)
{
SDL_Rect src;
src.x=(Sint16)poX;  src.y=(Sint16)poY;	src.w=1;  src.h=1;
SDL_FillRect(screen,&src,SDL_MapRGB(screen->format,0,63,255));
}
//------------------------------------------------------------------------------放物線を描く弾
void bullet_gravity()
{
//初期化
if(blt.flg==0)
	{
	blt.flg=1; blt.spd=2;	blt.rot=-rand()%90;
	blt.poX=WIW*0.5;	blt.poY=WIH*0.5;
	}
//移動方向＆移動量の検出
blt.moX=cos(blt.rot*PAI/180)*blt.spd;
blt.moY=sin(blt.rot*PAI/180)*blt.spd;
//移動計算
blt.poX+=blt.moX;	blt.poY+=blt.moY;
//描画
bullet_src(blt.poX,blt.poY);
//角度変更
if(	(blt.rot+=1)>90	)	blt.rot=90;
//画面外ならフラグ下げる
if(blt.poY>WIH)
	{
	blt.flg=0;
	if(	(blt.cnt+=1)>10	)
		{
		blt.cnt=0;
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));//バック地
		}
	}
}
//------------------------------------------------------------------------------メイン
int main(int argc,char *argv[])
{
inits();
while(quitLoop())
	{
	bullet_gravity();//弾
	me();//発射位置（中央砲台）
	upDate();//画面更新
	}
SDL_Quit();
return 0;
}